require("TextBox.lua")
require("Render3D.lua")

MyTextBox = TextBox:new(400,300,100,30,"my name is jake",.03)
MyRender3D = Render3D:new(0,0,math.sqrt(3),1024,1024,0) --veiwer is centerd and has 60 degree feild of veiw, min veiw distance is 0

locZ = 0

function love.keypressed(key,uni)
	MyTextBox.cKey = key
end

function love.load()
	love.graphics.setFont( "arialbd.ttf", 20 )
	MyRender3D:translate(0,0,20)
	MyRender3D.lx = 0.7
	MyRender3D.ly = 0
	MyRender3D.lz = 0.3
end

function love.draw()
	MyRender3D:clear()
	love.graphics.setBackgroundColor(255,255,255)
	
	
	local nx,ny,nz,mx,my,mz
	
	love.graphics.setColor(255,0,0,255)
	nx,ny,nz = Normal(0,0,0,4,0,0,4,4,0)
	MyRender3D:normal(nx,ny,nz)
	MyRender3D:triangle("fill",0,0,0,4,0,0,4,4,0)
	MyRender3D:triangle("fill",0,0,0,0,4,0,4,4,0)
	
	--love.graphics.setColor(255,0,0,255)
	nx,ny,nz = Normal(0,4,0,0,0,0,0,4,4)
	MyRender3D:normal(nx,ny,nz)
	MyRender3D:triangle("fill",0,4,0,0,0,0,0,4,4)
	MyRender3D:triangle("fill",0,0,0,0,4,4,0,0,4)
	
	--love.graphics.setColor(0,255,0,255)
	nx,ny,nz = Normal(4,0,0,4,4,0,4,4,4)
	MyRender3D:normal(nx,ny,nz)
	MyRender3D:triangle("fill",4,0,0,4,4,0,4,4,4)
	MyRender3D:triangle("fill",4,0,0,4,4,4,4,0,4)
	
	--love.graphics.setColor(0,0,255,255)
	nx,ny,nz = Normal(4,0,4,0,0,4,4,4,4)
	MyRender3D:normal(nx,ny,nz)
	MyRender3D:triangle("fill",4,0,4,0,0,4,4,4,4)
	MyRender3D:triangle("fill",0,0,4,0,4,4,4,4,4)
	
	--love.graphics.setColor(255,255,0,255)
	nx,ny,nz = Normal(0,0,4,0,0,0,4,0,4)
	MyRender3D:normal(nx,ny,nz)
	MyRender3D:triangle("fill",0,0,4,0,0,0,4,0,4)
	MyRender3D:triangle("fill",0,0,0,4,0,0,4,0,4)
	
	--love.graphics.setColor(255,0,255,255)
	nx,ny,nz = Normal(0,4,0,0,4,4,4,4,4)
	MyRender3D:normal(nx,ny,nz)
	MyRender3D:triangle("fill",0,4,0,0,4,4,4,4,4)
	MyRender3D:triangle("fill",0,4,0,4,4,0,4,4,4)
	
	love.graphics.setColor(0,0,0,255)
	
	love.graphics.print("x,y,z: "..MyRender3D.x..","..MyRender3D.y..","..MyRender3D.z,50,50)
	love.graphics.print("rx,ry,rz: "..MyRender3D.rx..","..MyRender3D.ry..","..MyRender3D.rz,50,80)
	
	love.graphics.print("controls:\n   w,s: z-axis\n   a,d: x-axis\n   up,down: y-axis\n   r,t: x rotation\n   q,e: z rotation\n   z,x: y rotation",50,150)
	
	MyRender3D:present()
end

function love.update(dt)
	if love.keyboard.isDown("w") then
		MyRender3D:translate(0,0,0.1)
	end
	if love.keyboard.isDown("a") then
		MyRender3D:translate(-0.1,0,0)
	end
	if love.keyboard.isDown("s") then
		MyRender3D:translate(0,0,-0.1)
	end
	if love.keyboard.isDown("d") then
		MyRender3D:translate(0.1,0,0)
	end
	if love.keyboard.isDown("up") then
		MyRender3D:translate(0,0.1,0)
	end
	if love.keyboard.isDown("down") then
		MyRender3D:translate(0,-0.1,0)
	end
	if love.keyboard.isDown("r") then
		MyRender3D:rotate(0.1,0,0)
	end
	if love.keyboard.isDown("t") then
		MyRender3D:rotate(-0.1,0,0)
	end
	if love.keyboard.isDown("q") then
		MyRender3D:rotate(0,0,0.1)
	end
	if love.keyboard.isDown("e") then
		MyRender3D:rotate(0,0,-0.1)
	end
	if love.keyboard.isDown("z") then
		MyRender3D:rotate(0,0.1,0)
	end
	if love.keyboard.isDown("x") then
		MyRender3D:rotate(0,-0.1,0)
	end
	if love.keyboard.isDown("g") then
		MyRender3D.lx = MyRender3D.lx - 1
	end
	if love.keyboard.isDown("h") then
		MyRender3D.lx = MyRender3D.lx + 1
	end
end

function love.run()
	
    if love.load then love.load() end

    local dt = 0

    -- Main loop time.
    while true do
        if love.timer then
            love.timer.step()
            dt = love.timer.getDelta()
        end
        if love.update then love.update(dt) end -- will pass 0 if love.timer is disabled
        if love.graphics then
            love.graphics.clear()
            if love.draw then love.draw() end
        end

        -- Process events.
        if love.event then
            for e,a,b,c in love.event.poll() do
                if e == "q" then
                    if not love.quit or not love.quit() then
                        if love.audio then
                            love.audio.stop()
                        end
                        return
                    end
                end
                love.handlers[e](a,b,c)
            end
        end

        if love.timer then love.timer.sleep(1) end
        if love.graphics then love.graphics.present() end

    end
end